package main

import (
	"fmt"
	"os"
	"path"
)

func (w *World) Draw(pix []byte) {
	for i, v := range w.gg[w.min].workingArea.area {
		switch v {
		case Empty:
			pix[4*i] = 0
			pix[4*i+1] = 0
			pix[4*i+2] = 0
			pix[4*i+3] = 0xff
		case 1:
			pix[4*i] = 139
			pix[4*i+1] = 0
			pix[4*i+2] = 1
			pix[4*i+3] = 0xff
		case 2:
			pix[4*i] = 158
			pix[4*i+1] = 23
			pix[4*i+2] = 17
			pix[4*i+3] = 0xff
		case 3:
			pix[4*i] = 177
			pix[4*i+1] = 46
			pix[4*i+2] = 33
			pix[4*i+3] = 0xff
		case 4:
			pix[4*i] = 195
			pix[4*i+1] = 70
			pix[4*i+2] = 50
			pix[4*i+3] = 0xff
		case 5:
			pix[4*i] = 233
			pix[4*i+1] = 116
			pix[4*i+2] = 82
			pix[4*i+3] = 0xff
		default:
			pix[4*i] = 0
			pix[4*i+1] = 255
			pix[4*i+2] = 0
			pix[4*i+3] = 0xff
		}
	}

	os.MkdirAll(path.Join("output", currentCity), os.ModePerm)
	f, _ := os.OpenFile(path.Join("output", currentCity, fmt.Sprintf(OutputFormat, yearStart, yearEnd)), os.O_CREATE|os.O_WRONLY, os.ModePerm)
	fmt.Fprintf(f, "%d\n", w.gg[w.min].rules.steps)
	for _, v := range w.gg[w.min].rules.koefs {
		fmt.Fprintf(f, "%f ", v)
	}
	fmt.Fprint(f, "\n")
	for _, v := range w.gg[0].rules.rules {
		fmt.Fprintf(f, "%f %f\n", v.degrade, v.evolve)
	}
}

func (w *World) dumpResults() {
	os.MkdirAll(path.Join("output", currentCity), os.ModePerm)
	f, _ := os.OpenFile(path.Join("output", currentCity, fmt.Sprintf("RES_"+OutputFormat, yearStart, yearEnd)), os.O_CREATE|os.O_WRONLY, os.ModePerm)
	matrix := ConfusionMatrix(&w.gg[w.min])
	for i := 0; i < len(Values); i++ {
		for j := 0; j < len(Values); j++ {
			fmt.Fprintf(f, "%d ", matrix[i*len(Values)+j])
		}
		fmt.Fprintf(f, "\n")
	}
}
