package main

import (
	"math"
)

func RRMSEFitness(g *Generation) float64 {
	var fitness float64
	var points int
	for i, v := range g.workingArea.area {
		w := float64(g.expectedArea.area[i])
		if v == Border || g.expectedArea.area[i] == Border {
			continue
		}
		vv := float64(v)

		fitness += math.Pow(float64(w-vv), 2) / float64(w+1)
		points++
	}

	fitness /= float64(points)
	fitness = math.Sqrt(fitness)

	return -1 * fitness
}

func ConfusionMatrix(g *Generation) [36]int {
	var matrix [36]int
	for i, v := range g.workingArea.area {
		w := g.expectedArea.area[i]
		if v == Border || w == Border {
			continue
		}
		matrix[v*6+w]++
	}

	return matrix
}
